<?php

require_once('../config.php');
require_once("../inc/errors.php");
require_once("../inc/auth.php");
require_once("../inc/meta.php");

try{
	require_once("../config.php");
	require_once("../inc/dbsetup.php");
} catch (Exception $e)
{
	$meta->setMessage("704", 'Tellervo server configuration file missing.  Contact your systems administrator');
}

try{
	require_once("../systemconfig.php");
} catch (Exception $e)
{
	$meta->setMessage("704", 'System configuration file missing.  Server administrator needs to run tellervo-server --reconfigure', E_USER_ERROR);
}


require_once("../inc/output.php");

//$odkauth = new ODKAuth();
$myAuth         = new auth();
$meta		= new meta();


if($myAuth->isLoggedIn===TRUE)
{
	$firebug->log("Logged in");
}
else
{
        // Not logged in
        $seq = $myAuth->sequence();
        $meta->requestLogin($myAuth->nonce($seq), $seq, 'Error');
        writeOutput($myMetaHeader, " ");
        die();
}

// ok, valid username & password


deleteFormList();
    writeOutput($meta);

function deleteFormList()
{
    global $dbconn;
    global $firebug;
    global $domain;
    global $securehttp;
    global $myAuth;
    global $meta;

    $sql = "DELETE FROM tblodkdefinition WHERE ownerid IN (SELECT securityuserid FROM tblsecurityuser WHERE securityuserid='".pg_escape_string($myAuth->getID())."' AND isactive=TRUE)";
	$firebug->log($sql);

    $dbconnstatus = pg_connection_status($dbconn);
    if ($dbconnstatus ===PGSQL_CONNECTION_OK)
    {
        pg_send_query($dbconn, $sql);
	$res = pg_get_result($dbconn);
	$err = pg_result_error($res);
	if(!$err=="")
	{
		$firebug->log("Error in sql ");
		$firebug->log($err);
		$meta->setMessage("000", $err);
		$xmldata = "<hello/>";
    		writeOutput($meta, $xmldata);
		die();
	}
	
    }
    else
    {
		$meta->setMessage("000", "DB connection error");
		$xmldata = "<hello/>";
    		writeOutput($meta, $xmldata);
		die();
    }


}




